<?php

namespace App\Controllers\Admin\Cloudflare;

use App\Controllers\Admin\AdminController;
use App\Models\Cloudflare\AccountModel;
use App\Models\Cloudflare\AuthModel;
use App\Models\Cloudflare\RecordModel;
use App\Models\Cloudflare\ZoneModel;
use CodeIgniter\HTTP\RedirectResponse;
use CodeIgniter\HTTP\RequestInterface;
use CodeIgniter\HTTP\ResponseInterface;
use Psr\Log\LoggerInterface;

abstract class CloudflareController extends AdminController
{
    private $_authModel = null;
    private $_accountModel = null;
    private $_zoneModel = null;
    private $_recordModel = null;
    public function initController(RequestInterface $request, ResponseInterface $response, LoggerInterface $logger)
    {
        parent::initController($request, $response, $logger);
        $this->class_path = "Cloudflare/";
        $this->uri_path .= strtolower($this->class_path);
    }
    final protected function getAuthModel(): AuthModel
    {
        if ($this->_authModel === null) {
            $this->_authModel = new AuthModel();
        }
        return $this->_authModel;
    }
    final protected function getAccountModel(): AccountModel
    {
        if ($this->_accountModel === null) {
            $this->_accountModel = new AccountModel();
        }
        return $this->_accountModel;
    }
    final protected function getZoneModel(): ZoneModel
    {
        if ($this->_zoneModel === null) {
            $this->_zoneModel = new ZoneModel();
        }
        return $this->_zoneModel;
    }
    final protected function getRecordModel(): RecordModel
    {
        if ($this->_recordModel === null) {
            $this->_recordModel = new RecordModel();
        }
        return $this->_recordModel;
    }
    protected function sync_process(string $uid): void {}
    final protected function sync_procedure(string $uid): RedirectResponse
    {
        //Transaction Start
        $this->getModel()->transStart();
        try {
            $this->sync_process($uid);
            $this->message = "{$this->class_name}: 동기화작업을 완료하였습니다.";
            $this->getModel()->transCommit();
            log_message("notice", __FUNCTION__ . $this->message);
            // 이전 URL로 리다이렉트
            return redirect()->to($this->popPreviousUrl())->with('error', $this->message);
        } catch (\Exception $e) {
            //Transaction Rollback
            $this->getModel()->transRollback();
            log_message("error", $e->getMessage());
            return redirect()->back()->with('error', __FUNCTION__ . " 실패하였습니다.\n" . $e->getMessage());
        }
    }

    protected function reload_process(mixed $uid): void {}
    final protected function reload_procedure(mixed $uid): RedirectResponse
    {
        //Transaction Start
        $this->getModel()->transStart();
        try {
            $this->reload_process($uid);
            $this->message = "{$this->class_name}: Reload 작업이 완료되었습니다.";
            $this->getModel()->transCommit();
            log_message("notice", __FUNCTION__ . $this->message);
            // 이전 URL로 리다이렉트
            return redirect()->to($this->popPreviousUrl())->with('error', $this->message);
        } catch (\Exception $e) {
            //Transaction Rollback
            $this->getModel()->transRollback();
            log_message("error", $e->getMessage());
            return redirect()->back()->with('error', __FUNCTION__ . " 실패하였습니다.\n" . $e->getMessage());
        }
    }
}
